Bug 9636 - pidl can't parse new linemarkers in preprocessor output
pidl can't parse new linemarkers in preprocessor output
Status: RESOLVED FIXED
Product: Samba 4.0
Classification: Unclassified
Component: Build
4.0.3
All All
: P5 normal
: ---
Assigned To: Karolin Seeger
Samba QA Contact
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2013-02-06 10:31 UTC by Andreas Schneider
Modified: 2013-07-04 08:02 UTC (History)
0 users

See Also:


Attachments
v4-0-test patch (2.09 KB, patch)
2013-02-06 13:05 UTC, Andreas Schneider
ab: review+
Details
Patch with cherry-pick information for v3-6-test (2.24 KB, patch)
2013-07-03 08:24 UTC, Karolin Seeger
asn: review+
ab: review+
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Andreas Schneider 2013-02-06 10:31:38 UTC
When PIDL calls out to C preprocessor to expand IDL files and parse the output, it filters out linemarkers and line control information as described in http://gcc.gnu.org/onlinedocs/cpp/Preprocessor-Output.html
and http://gcc.gnu.org/onlinedocs/cpp/Line-Control.html#Line-Control

With gcc 4.8 stdc-predef.h is included automatically and linemarker for the file has extended flags that PIDL can't parse ('system header that needs to be extern "C" protected for C++').

The following patch fixes the problem.
Comment 1 Andreas Schneider 2013-02-06 13:05:59 UTC
Created attachment 8533 [details]
v4-0-test patch
Comment 2 Alexander Bokovoy 2013-02-06 14:11:21 UTC
Comment on attachment 8533 [details]
v4-0-test patch

Works on Fedora Rawhide and F18.
Comment 3 Andreas Schneider 2013-02-06 16:34:52 UTC
Karolin, please add the patch to v4-0-test.
Comment 4 Karolin Seeger 2013-02-07 08:53:58 UTC
Pushed to autobuild-v4-0-test.
Comment 5 Karolin Seeger 2013-02-13 18:29:21 UTC
Pushed to v4-0-test.
Closing out bug report.

Thanks!
Comment 6 David Disseldorp 2013-07-02 13:38:58 UTC
This problem is also present in Samba 3.6 PIDL.
@Karolin, please merge the same patch to the 3.6 branch.
Comment 7 Karolin Seeger 2013-07-03 08:24:47 UTC
Created attachment 9020 [details]
Patch with cherry-pick information for v3-6-test

Patch with cherry-pick information for v3-6-test
Comment 8 Karolin Seeger 2013-07-03 08:27:22 UTC
(In reply to comment #6)
> This problem is also present in Samba 3.6 PIDL.
> @Karolin, please merge the same patch to the 3.6 branch.

The patch applies cleanly, but I need 2 review flags to be able to push it to v3-6-test.

Thanks!
Comment 9 Alexander Bokovoy 2013-07-03 10:12:55 UTC
Comment on attachment 9020 [details]
Patch with cherry-pick information for v3-6-test

Ok for me.
Comment 10 Andreas Schneider 2013-07-03 11:49:54 UTC
Karolin, please add the patch to v3-6-test.
Comment 11 Karolin Seeger 2013-07-04 08:02:31 UTC
Pushed to v3-6-test.
Closing out bug report.

Thanks!